This service will be undergoing maintenance at 00:00 UTC, 2016-08-01. It is expected to last about 1 hours
Bug 732654 - during kernel update, grubby does not correctly update the "echo 'Loading ...' line
during kernel update, grubby does not correctly update the "echo 'Loading ......
Status: CLOSED CURRENTRELEASE
Product: Fedora
Classification: Fedora
Component: grubby (Show other bugs)
18
All Linux
unspecified Severity unspecified
: ---
: ---
Assigned To: Peter Jones
Fedora Extras Quality Assurance
RejectedNTH https://fedoraproject.org...
: CommonBugs, Reopened
: 741847 743119 747542 749963 751601 751604 755706 757198 757235 757406 757437 760596 761400 766057 (view as bug list)
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2011-08-23 04:28 EDT by Joachim Backes
Modified: 2014-01-07 13:29 EST (History)
33 users (show)

See Also:
Fixed In Version: grubby-8.3-2.fc16
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2014-01-07 13:29:47 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:


Attachments (Terms of Use)
grub.cfg on affected F16 x86_64 system (always says "Loading Fedora (3.0.0-3.fc16.x86_64)") (2.55 KB, text/plain)
2011-08-26 05:09 EDT, Andre Robatino
no flags Details
loading.patch (1.22 KB, patch)
2011-09-14 10:21 EDT, Mads Kiilerich
no flags Details | Diff
updated patch that doesn't hardcode the customizable title (4.73 KB, patch)
2011-10-29 14:14 EDT, Mads Kiilerich
no flags Details | Diff

  None (edit)
Description Joachim Backes 2011-08-23 04:28:38 EDT
Description of problem:
I updated from kernel-3.0.1-3.fc16.x86_64 to kernel-3.1.0-0.rc2.git7.2.fc16.x86_64.

But the update procedure did not update the echo line 

	echo 'Loading Fedora (3.0.1-3.fc16.x86_64)'

into 
	echo 'Loading Fedora (3.1.0-0.rc2.git7.2.fc16.x86_64)'

for the menu entry of kernel-3.1.0-0.rc2.git7.2.fc16.x86_64.

That menu entry for kernel-3.1.0-0.rc2.git7.2.fc16.x86_64 is:

menuentry 'Fedora (3.1.0-0.rc2.git7.2.fc16.x86_64)' --class fedora --class gnu-linux --class gnu --class os {
        load_video
        set gfxpayload=keep
        insmod part_msdos
        insmod ext2
        search --no-floppy --label --set=root /F16
        echo 'Loading Fedora (3.0.1-3.fc16.x86_64)'
        linux   /boot/vmlinuz-3.1.0-0.rc2.git7.2.fc16.x86_64 root=LABEL=/F16 ro rd.md=0 rd.lvm=0 rd.dm=0 quiet SYSFONT=latarcyrheb-sun16 rhgb rd.luks=0  KEYTABLE=de-latin1-nodeadkeys LANG=en_US.UTF-8
        echo 'Loading initial ramdisk ...'
        initrd /boot/initramfs-3.1.0-0.rc2.git7.2.fc16.x86_64.img
}

and the menu entry of kernel-3.0.1-3.fc16.x86_64:

menuentry 'Fedora (3.0.1-3.fc16.x86_64)' --class fedora --class gnu-linux --class gnu --class os {
        load_video
        set gfxpayload=keep
        insmod part_msdos
        insmod ext2
        search --no-floppy --label --set=root /F16
        echo 'Loading Fedora (3.0.1-3.fc16.x86_64)'
        linux   /boot/vmlinuz-3.0.1-3.fc16.x86_64 root=LABEL=/F16 ro rd.md=0 rd.lvm=0 rd.dm=0 quiet SYSFONT=latarcyrheb-sun16 rhgb rd.luks=0  KEYTABLE=de-latin1-nodeadkeys LANG=en_US.UTF-8
        echo 'Loading initial ramdisk ...'
        initrd /boot/initramfs-3.0.1-3.fc16.x86_64.img




Version-Release number of selected component (if applicable):
kernel-3.1.0-0.rc2.git7.2.fc16.x86_64

How reproducible:
Did not try!

Steps to Reproduce:
1.
2.
3.
  
Actual results:


Expected results:


Additional info: The newer kernel is bootetd correctly!
Comment 1 Joachim Backes 2011-08-23 08:39:30 EDT
The loading message is again correct with 3.1.0-0.rc3.git0.0.fc16.x86_64.
Comment 2 Joachim Backes 2011-08-24 02:39:22 EDT
(In reply to comment #1)
> The loading message is again correct with 3.1.0-0.rc3.git0.0.fc16.x86_64.

Please reopen the bug! It's *not correct* that is has been solved by 3.1.0-0.rc3.git0.0.fc16.x86_64.
Comment 3 Andre Robatino 2011-08-26 04:15:16 EDT
Reopened - I'm surprised Bugzilla doesn't let you reopen your own bug. Also set the Platform to "x86_64 Linux", since I can only vouch for it on x86_64, but it's likely it happens on i386 as well.
Comment 4 Andre Robatino 2011-08-26 05:09:47 EDT
Created attachment 520038 [details]
grub.cfg on affected F16 x86_64 system (always says "Loading Fedora (3.0.0-3.fc16.x86_64)")
Comment 5 Andre Robatino 2011-08-29 12:13:44 EDT
Changing the Component to grubby based on the thread http://lists.fedoraproject.org/pipermail/test/2011-August/102191.html . On Rawhide, I used "grub2-mkconfig -o /boot/grub2/grub.cfg" to recreate grub.cfg, and after installing a new kernel, it was updated correctly, so I don't know if the bug even still exists. Also ran the same command on F16 but am waiting for a kernel update to see if it works properly there as well.
Comment 6 Andre Robatino 2011-08-30 22:47:37 EDT
After the latest F16 kernel update, grubby updates correctly there as well. Anyone know if this bug is already fixed?
Comment 7 Andre Robatino 2011-08-31 10:04:47 EDT
I am now seeing the wrong echo line in Rawhide for the latest kernel, so the bug still exists. The file grub.cfg was last modified yesterday at 11:26 (local time), just before booting into the new kernel which I had just installed.

[root@localhost ~]# last -3 reboot
reboot   system boot  3.1.0-0.rc4.git0 Wed Aug 31 09:53 - 10:03  (00:09)    
reboot   system boot  3.1.0-0.rc4.git0 Tue Aug 30 11:28 - 11:36  (00:08)    
reboot   system boot  3.1.0-0.rc3.git5 Tue Aug 30 10:57 - 11:27  (00:30)    

wtmp begins Sat Aug  6 15:19:15 2011
[root@localhost ~]#

Bad section of grub.cfg:

menuentry 'Fedora (3.1.0-0.rc4.git0.0.fc17.x86_64)' --class gnu-linux --class gnu --class os {
        load_video
        set gfxpayload=keep
        insmod part_gpt
        insmod ext2
        set root='(hd0,gpt2)'
        search --no-floppy --fs-uuid --set=root 35c75285-d5e2-4ff5-a487-6a31bae0c421
        echo 'Loading Fedora (3.1.0-0.rc3.git5.0.fc17.x86_64)'
        linux   /vmlinuz-3.1.0-0.rc4.git0.0.fc17.x86_64 root=/dev/mapper/VolGroup-lv_root ro SYSFONT=latarcyrheb-sun16 LANG=en_US.UTF-8 KEYTABLE=us
        echo 'Loading initial ramdisk ...'
        initrd /initramfs-3.1.0-0.rc4.git0.0.fc17.x86_64.img
}
Comment 8 Joachim Backes 2011-08-31 11:58:06 EDT
I can confirm this.
Comment 9 Mads Kiilerich 2011-09-14 10:21:15 EDT
Created attachment 523165 [details]
loading.patch

grub2-mkconfig will create lines like:
        echo    'Loading Linux 3.1.0-0.rc6.git0.0.fc16.x86_64 ...'

grubby will correctly recognize these lines and replace them with lines with
the right version number such as:
        echo 'Loading Fedora (3.1.0-0.rc6.git0.0.fc16.x86_64)'

these lines are however not recognized by grubby and will not be updated next
time.

We need to update all the right kinds of 'Loading' messages to the new kernel version

This patch makes sure that "'Loading Fedora " also is recognized and updated
correctly.

It could be argued that the extra parens are ugly and that grubby and mkconfig
should emit the same output, but that's a different issue. Both kinds are out
there in the wild and we have to handle both.
Comment 10 Charles R. Anderson 2011-09-20 16:56:00 EDT
I'm seeing the same issue throughout rc4, rc5, rc6 kernels.  It always  shows "Loading ..." for the previously updated kernel.  I.e. Loading rc6 echo rc5, loading rc5 echos rc4, etc.
Comment 11 Dr. Tilmann Bubeck 2011-10-12 16:03:50 EDT
This seems to be a duplicate of bugzilla #743119 or vice versa.
Comment 12 Charles R. Anderson 2011-10-12 16:25:35 EDT
Patch available in bug #743119.

*** This bug has been marked as a duplicate of bug 743119 ***
Comment 13 Andre Robatino 2011-10-17 12:31:07 EDT
Reopened since essentially exactly the same patch was already available in this bug in comment 9.
Comment 14 Andre Robatino 2011-10-17 12:32:51 EDT
*** Bug 743119 has been marked as a duplicate of this bug. ***
Comment 15 Andre Robatino 2011-10-20 11:10:48 EDT
*** Bug 747542 has been marked as a duplicate of this bug. ***
Comment 16 Adam Williamson 2011-10-21 14:29:28 EDT
Discussed at 2011-10-21 NTH review meeting. Agreed this is not an NTH issue; it has no actual practical impact and can be fixed safely with a post-release update. It doesn't affect initial install, because anaconda uses grub2-mkconfig, not grubby. This bug only happens when grubby is using an existing kernel entry as a template, which _only_ happens in post-install kernel updates.
Comment 17 Andre Robatino 2011-10-29 12:09:33 EDT
*** Bug 749963 has been marked as a duplicate of this bug. ***
Comment 18 Adam Williamson 2011-10-29 13:20:20 EDT

-- 
Fedora Bugzappers volunteer triage team
https://fedoraproject.org/wiki/BugZappers
Comment 19 Mads Kiilerich 2011-10-29 14:14:06 EDT
Created attachment 530798 [details]
updated patch that doesn't hardcode the customizable title

Update "echo 'Loading..." messages to the new kernel version

grub2-mkconfig will create lines like:
        echo    'Loading Linux 3.1.0-0.rc6.git0.0.fc16.x86_64 ...'
- depending on the content of /etc/default/grub.

grubby would recognize these lines and replace them with lines with the right
version number such as:
        echo 'Loading Fedora (3.1.0-0.rc6.git0.0.fc16.x86_64)'

these lines were however not recognized by grubby and would not be updated on
next kernel update when this entry would be used as template.

With this patch grubby will no longer look for a specific title but patch any
"echo 'Loading" line immediately before the kernel line.
Comment 20 Andre Robatino 2011-11-06 09:33:57 EST
*** Bug 751604 has been marked as a duplicate of this bug. ***
Comment 21 Andre Robatino 2011-11-06 13:26:06 EST
*** Bug 751601 has been marked as a duplicate of this bug. ***
Comment 22 Adam Williamson 2011-11-08 01:26:03 EST

-- 
Fedora Bugzappers volunteer triage team
https://fedoraproject.org/wiki/BugZappers
Comment 23 Andre Robatino 2011-11-22 00:42:38 EST
*** Bug 755706 has been marked as a duplicate of this bug. ***
Comment 24 Mads Kiilerich 2011-11-25 11:14:43 EST
*** Bug 741847 has been marked as a duplicate of this bug. ***
Comment 25 Brian Lane 2011-11-28 13:54:46 EST
*** Bug 757437 has been marked as a duplicate of this bug. ***
Comment 26 Brian Lane 2011-11-28 14:08:24 EST
*** Bug 757198 has been marked as a duplicate of this bug. ***
Comment 27 Brian Lane 2011-11-28 14:09:24 EST
*** Bug 757235 has been marked as a duplicate of this bug. ***
Comment 28 Brian Lane 2011-12-06 12:15:49 EST
*** Bug 760596 has been marked as a duplicate of this bug. ***
Comment 29 Bill Gianopoulos 2011-12-07 19:45:44 EST
(In reply to comment #19)
> Created attachment 530798 [details]

If there is some overriding issue with this patch, could we at least put in a
patch to just not insert the "echo Loading ...." line at all?  This way just
makes it look like the incorrect kernel is being booted which is just not a
very good thing at all.
Comment 30 Josh Boyer 2011-12-08 08:36:19 EST
*** Bug 761400 has been marked as a duplicate of this bug. ***
Comment 31 Mads Kiilerich 2011-12-08 14:07:22 EST
*** Bug 757406 has been marked as a duplicate of this bug. ***
Comment 32 Peter Jones 2011-12-08 14:22:52 EST
Mads, can you attach an updated patch that's in a format "git am" will recognize?
Comment 33 Adam Williamson 2011-12-08 14:46:55 EST
it's okay, I'll do it.



-- 
Fedora Bugzappers volunteer triage team
https://fedoraproject.org/wiki/BugZappers
Comment 34 Fedora Update System 2011-12-09 12:44:00 EST
grubby-8.3-2.fc16 has been submitted as an update for Fedora 16.
https://admin.fedoraproject.org/updates/grubby-8.3-2.fc16
Comment 35 Fedora Update System 2011-12-10 14:57:04 EST
Package grubby-8.3-2.fc16:
* should fix your issue,
* was pushed to the Fedora 16 testing repository,
* should be available at your local mirror within two days.
Update it with:
# su -c 'yum update --enablerepo=updates-testing grubby-8.3-2.fc16'
as soon as you are able to.
Please go to the following url:
https://admin.fedoraproject.org/updates/FEDORA-2011-16908/grubby-8.3-2.fc16
then log in and leave karma (feedback).
Comment 36 Bill Gianopoulos 2011-12-10 15:09:00 EST
(In reply to comment #35)
> Package grubby-8.3-2.fc16:
> * should fix your issue,
> * was pushed to the Fedora 16 testing repository,
> * should be available at your local mirror within two days.
> Update it with:
> # su -c 'yum update --enablerepo=updates-testing grubby-8.3-2.fc16'
> as soon as you are able to.
> Please go to the following url:
> https://admin.fedoraproject.org/updates/FEDORA-2011-16908/grubby-8.3-2.fc16
> then log in and leave karma (feedback).

Do we know if there will be a kernel update soon?  Or do I need to backout the most recent kernel version and re-update the kernel in order to test this?
Comment 38 Joachim Backes 2011-12-11 03:42:24 EST
(In reply to comment #35)
> Package grubby-8.3-2.fc16:
> * should fix your issue,
> * was pushed to the Fedora 16 testing repository,
> * should be available at your local mirror within two days.
> Update it with:
> # su -c 'yum update --enablerepo=updates-testing grubby-8.3-2.fc16'
> as soon as you are able to.
> Please go to the following url:
> https://admin.fedoraproject.org/updates/FEDORA-2011-16908/grubby-8.3-2.fc16
> then log in and leave karma (feedback).

Displays now the right echo line after updating to kernel-3.1.5-1.fc16.x86_64 and rebooting :-)
Comment 39 Andre Robatino 2011-12-11 04:00:54 EST
*** Bug 766057 has been marked as a duplicate of this bug. ***
Comment 40 Fedora Update System 2011-12-11 16:53:01 EST
grubby-8.3-2.fc16 has been pushed to the Fedora 16 stable repository.  If problems still persist, please make note of it in this bug report.
Comment 41 Adam Williamson 2011-12-12 16:04:32 EST
bill: they usually come along fairly frequently, but you can just do a 'yum reinstall' if you want to test it right away.



-- 
Fedora Bugzappers volunteer triage team
https://fedoraproject.org/wiki/BugZappers
Comment 42 Julian Sikorski 2012-06-10 03:49:15 EDT
This bug seems to walk the earth again in grub2-2.0-0.25.beta4.fc17.x86_64. It is translated now, so maybe this is the source of the problem:

### BEGIN /etc/grub.d/10_linux ###
menuentry 'Fedora (3.4.0-1.fc17.x86_64)' --class fedora --class gnu-linux --class gnu --class os $menuentry_id_option 'gnulinux-simple-67681f12-ee66-41a0-b18e-feed75f27622' {
	load_video
	set gfxpayload=keep
	insmod gzio
	insmod part_msdos
	insmod ext2
	set root='hd0,msdos3'
	if [ x$feature_platform_search_hint = xy ]; then
	  search --no-floppy --fs-uuid --set=root --hint-bios=hd0,msdos3 --hint-efi=hd0,msdos3 --hint-baremetal=ahci0,msdos3 --hint='hd0,msdos3'  ec9db239-05ec-4dd0-9f70-7ae8e00162d9
	else
	  search --no-floppy --fs-uuid --set=root ec9db239-05ec-4dd0-9f70-7ae8e00162d9
	fi
	echo 'Wczytywanie systemu Linux 3.3.7-1.fc17.x86_64...'
	linux	/vmlinuz-3.4.0-1.fc17.x86_64 root=/dev/mapper/vg_snowball2-lv_root ro rd.lvm.lv=vg_snowball2/lv_swap rd.md=0 rd.dm=0 quiet SYSFONT=latarcyrheb-sun16 rhgb rd.lvm.lv=vg_snowball2/lv_root rd.luks=0 LANG=pl_PL.UTF-8  KEYTABLE=pl2 nouveau.modeset=0 rd.driver.blacklist=nouveau
	echo 'Wczytywanie początkowego dysku RAM...'
	initrd /initramfs-3.4.0-1.fc17.x86_64.img
}
Comment 43 Eli Wapniarski 2012-06-11 05:38:57 EDT
I have the same issue.
Comment 44 Thomas Müller 2012-08-04 04:06:54 EDT
Same issue here with German localization on Fedora 17.

Just updated to the 3.5.0 kernel, but the echo-line still mentions 3.4.6.


# rpm -q grubby
grubby-8.12-1.fc17.x86_64


menuentry 'Fedora (3.5.0-2.fc17.x86_64)' --class fedora --class gnu-linux --class gnu --class os $menuentry_id_option 'gnulinux-simple-[...]' {
        [...]
        echo 'Linux 3.4.6-2.fc17.x86_64 wird geladen …'
        linux   /vmlinuz-3.5.0-2.fc17.x86_64 root=UUID=[...]
        echo 'Initiale Ramdisk wird geladen …'
        initrd /initramfs-3.5.0-2.fc17.x86_64.img
}
Comment 45 Pavlo Rudyi 2012-08-17 11:32:35 EDT
F17, Ukrainian localization.

Updated to kernel 3.5.2, in grub.cfg:
	echo 'Завантаження Linux 3.4.4-5.fc17.x86_64…'




rpm -q grubby
#  rpm -q grubby
grubby-8.12-1.fc17.x86_64
Comment 46 Fedora End Of Life 2013-02-13 21:12:14 EST
Fedora 16 changed to end-of-life (EOL) status on 2013-02-12. Fedora 16 is 
no longer maintained, which means that it will not receive any further 
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of 
Fedora please feel free to reopen this bug against that version.

Thank you for reporting this bug and we are sorry it could not be fixed.
Comment 47 Aissen 2013-04-29 07:04:54 EDT
I can confirm this problem on F18.
Comment 48 Aissen 2013-04-29 07:05:29 EDT
I can confirm this problem on F18, with a localized description.
Comment 49 Fedora End Of Life 2013-12-21 09:56:55 EST
This message is a reminder that Fedora 18 is nearing its end of life.
Approximately 4 (four) weeks from now Fedora will stop maintaining
and issuing updates for Fedora 18. It is Fedora's policy to close all
bug reports from releases that are no longer maintained. At that time
this bug will be closed as WONTFIX if it remains open with a Fedora 
'version' of '18'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version prior to Fedora 18's end of life.

Thank you for reporting this issue and we are sorry that we may not be 
able to fix it before Fedora 18 is end of life. If you would still like 
to see this bug fixed and are able to reproduce it against a later version 
of Fedora, you are encouraged  change the 'version' to a later Fedora 
version prior to Fedora 18's end of life.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events. Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.
Comment 50 Joachim Backes 2013-12-21 12:01:43 EST
No more such problem in F20; obviously fixed in F20

Note You need to log in before you can comment on or make changes to this bug.